## cc65 2.17

=== doc/Makefile ===
ifneq ($(shell echo),)
  CMD_EXE = 1
endif

.PHONY: all mostlyclean clean install zip doc html info

.SUFFIXES:

htmldir = $(PREFIX)/share/doc/cc65$(DESTPACKAGE_SUFFIX)/html
infodir = $(PREFIX)/share/info

ifdef CMD_EXE

doc clean install zip:

else # CMD_EXE

SGMLS := $(wildcard *.sgml)

../html/coding.html ../html/index.html: \
TOC_LEVEL = 0

TOC_LEVEL = 2

INSTALL = install

doc: html info

html: $(addprefix ../html/,$(SGMLS:.sgml=.html) doc.css doc.png)

info: $(addprefix ../info/,$(SGMLS:.sgml=.info))

../html ../info:
	@mkdir $@

../html/%.html: %.sgml header.html | ../html
	@cd ../html && linuxdoc -B html -s 0 -T $(TOC_LEVEL) -H ../doc/header.html ../doc/$<

../html/doc.%: doc.% | ../html
	cp $< ../html

../info/%.info: %.sgml | ../info
	@cd ../info && linuxdoc -B info ../doc/$<

clean:
	$(RM) -r ../html ../info

install:
	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
ifeq ($(wildcard ../html),../html)
	$(INSTALL) -d $(DESTDIR)$(htmldir)
	$(INSTALL) -m0644 ../html/*.* $(DESTDIR)$(htmldir)
endif
ifeq ($(wildcard ../info),../info)
	$(INSTALL) -d $(DESTDIR)$(infodir)
	$(INSTALL) -m0644 ../info/*.* $(DESTDIR)$(infodir)
endif

zip:
ifneq "$(wildcard ../html)" ""
	@cd .. && zip cc65 html/*.*
endif

endif # CMD_EXE

all mostlyclean:

=== libsrc/Makefile ===
ifneq ($(shell echo),)
  CMD_EXE = 1
endif

CBMS = c128   \
       c16    \
       c64    \
       cbm510 \
       cbm610 \
       pet    \
       plus4  \
       vic20

GEOS = geos-apple \
       geos-cbm

TARGETS = apple2       \
          apple2enh    \
          atari        \
          atarixl      \
          atari2600    \
          atari5200    \
          atmos        \
          creativision \
          $(CBMS)      \
          $(GEOS)      \
          gamate       \
          lynx         \
          nes          \
          none         \
          osic1p       \
          pce          \
          sim6502      \
          sim65c02     \
          supervision  \
          telestrat

DRVTYPES = emd \
           joy \
           mou \
           ser \
           tgi

OUTPUTDIRS := lib                                                                             \
              asminc                                                                          \
              cfg                                                                             \
              include                                                                         \
              $(subst ../,,$(filter-out $(wildcard ../include/*.*),$(wildcard ../include/*))) \
              $(subst ../,,$(wildcard ../target/*/drv/*))                                     \
              $(subst ../,,$(wildcard ../target/*/util))

.PHONY: all mostlyclean clean install zip lib $(TARGETS)

.SUFFIXES:

ifdef CMD_EXE
  DIRLIST = $(strip $(foreach dir,$1,$(wildcard $(dir))))
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = $(if $(DIRLIST),rmdir /s /q $(subst /,\,$(DIRLIST)))
else
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
endif

# Every target requires its individual vpath setting but the vpath directive
# acts globally. Therefore each target is built in a separate make instance.

ifeq ($(words $(MAKECMDGOALS)),1)
  ifeq ($(MAKECMDGOALS),$(filter $(MAKECMDGOALS),$(TARGETS)))
    TARGET = $(MAKECMDGOALS)
  endif
endif

ifndef TARGET

datadir = $(PREFIX)/share/cc65

all lib: $(TARGETS)

mostlyclean:
	$(call RMDIR,../libwrk)

clean:
	$(call RMDIR,../libwrk ../lib ../target)

ifdef CMD_EXE

install:

else # CMD_EXE

INSTALL = install

define INSTALL_recipe

$(if $(PREFIX),,$(error variable `PREFIX' must be set))
$(INSTALL) -d $(DESTDIR)$(datadir)/$(dir)
$(INSTALL) -m0644 ../$(dir)/*.* $(DESTDIR)$(datadir)/$(dir)

endef # INSTALL_recipe

install:
	$(foreach dir,$(OUTPUTDIRS),$(INSTALL_recipe))

endif # CMD_EXE

define ZIP_recipe

@cd .. && zip cc65 $(dir)/*.*

endef # ZIP_recipe

zip:
	$(foreach dir,$(OUTPUTDIRS),$(ZIP_recipe))

$(TARGETS):
	@$(MAKE) --no-print-directory $@

else # TARGET

CA65FLAGS =
CC65FLAGS = -Or -W error

EXTZP = cbm510 \
        cbm610 \
        lynx

MKINC = $(GEOS) \
        atari   \
        atarixl \
        nes

TARGETUTIL = apple2    \
             apple2enh \
             atari     \
             geos-apple

GEOSDIRS = common      \
           conio       \
           disk        \
           dlgbox      \
           file        \
           graph       \
           memory      \
           menuicon    \
           mousesprite \
           process     \
           runtime     \
           system

ifeq ($(TARGET),apple2enh)
  SRCDIR = apple2
  OBJPFX = a2
  DRVPFX = a2e
else ifeq ($(TARGET),atarixl)
  SRCDIR = atari
  OBJPFX = atr
  DRVPFX = atrx
else ifeq ($(TARGET),sim65c02)
  SRCDIR = sim6502
else
  SRCDIR = $(TARGET)
endif

SRCDIRS = $(SRCDIR)

ifeq ($(TARGET),$(filter $(TARGET),$(CBMS)))
  SRCDIRS += cbm
endif

ifeq ($(TARGET),$(filter $(TARGET),$(GEOS)))
  SRCDIRS += $(addprefix $(TARGET)/,  $(GEOSDIRS))
  SRCDIRS += $(addprefix geos-common/,$(GEOSDIRS))
endif

SRCDIRS += common   \
           conio    \
           dbg      \
           em       \
           joystick \
           mouse    \
           runtime  \
           serial   \
           tgi      \
           zlib

vpath %.s $(SRCDIRS)
vpath %.c $(SRCDIRS)

OBJS := $(patsubst %.s,%.o,$(foreach dir,$(SRCDIRS),$(wildcard $(dir)/*.s)))
OBJS += $(patsubst %.c,%.o,$(foreach dir,$(SRCDIRS),$(wildcard $(dir)/*.c)))

OBJS := $(addprefix ../libwrk/$(TARGET)/,$(sort $(notdir $(OBJS))))

DEPS = $(OBJS:.o=.d)

EXTRA_SRCPAT = $(SRCDIR)/extra/%.s
EXTRA_OBJPAT = ../lib/$(TARGET)-%.o
EXTRA_OBJS := $(patsubst $(EXTRA_SRCPAT),$(EXTRA_OBJPAT),$(wildcard $(SRCDIR)/extra/*.s))
DEPS += $(EXTRA_OBJS:../lib/%.o=../libwrk/$(TARGET)/%.d)

ZPOBJ = ../libwrk/$(TARGET)/zeropage.o
ifeq ($(TARGET),$(filter $(TARGET),$(EXTZP)))
  ZPOBJ += ../libwrk/$(TARGET)/extzp.o
endif

ifeq ($(TARGET),$(filter $(TARGET),$(MKINC)))
  include $(SRCDIR)/Makefile.inc
endif

ifeq ($(TARGET),$(filter $(TARGET),$(TARGETUTIL)))
  include $(SRCDIR)/targetutil/Makefile.inc
endif

define DRVTYPE_template

$1_SRCDIR = $$(SRCDIR)/$1
$1_STCDIR = ../libwrk/$$(TARGET)
$1_DYNDIR = ../libwrk/$$(TARGET)/$1
$1_DRVDIR = ../target/$$(TARGET)/drv/$1

$1_SRCPAT = $$($1_SRCDIR)/$$(OBJPFX)%.s
$1_STCPAT = $$($1_STCDIR)/$$(OBJPFX)%-$1.o
$1_DYNPAT = $$($1_DYNDIR)/$$(OBJPFX)%.o
$1_DRVPAT = $$($1_DRVDIR)/$$(DRVPFX)%.$1

$1_SRCS := $$(wildcard $$($1_SRCDIR)/*.s)
$1_STCS = $$(patsubst $$($1_SRCPAT),$$($1_STCPAT),$$($1_SRCS))
$1_DYNS = $$(patsubst $$($1_SRCPAT),$$($1_DYNPAT),$$($1_SRCS))
$1_DRVS = $$(patsubst $$($1_DYNPAT),$$($1_DRVPAT),$$($1_DYNS))

$$($1_STCPAT): $$($1_SRCPAT)
	@echo $$(TARGET) - $$< - static
	@$$(CA65) -t $$(TARGET) -D DYN_DRV=0 $$(CA65FLAGS) --create-dep $$(@:.o=.d) -o $$@ $$<

OBJS += $$($1_STCS)
DEPS += $$($1_STCS:.o=.d)

$$($1_DYNS): | $$($1_DYNDIR)

$$($1_DRVPAT): $$($1_DYNPAT) $$(ZPOBJ) | $$($1_DRVDIR)
	@echo $$(TARGET) - $$(<F)
	@$$(LD65) -o $$@ -t module $$^

$$($1_DYNDIR) $$($1_DRVDIR):
	@$$(call MKDIR,$$@)

$(TARGET): $$($1_DRVS)

DEPS += $$($1_DYNS:.o=.d)

endef # DRVTYPE_template

$(foreach drvtype,$(DRVTYPES),$(eval $(call DRVTYPE_template,$(drvtype))))

AR65 := $(if $(wildcard ../bin/ar65*),../bin/ar65,ar65)
CA65 := $(if $(wildcard ../bin/ca65*),../bin/ca65,ca65)
CC65 := $(if $(wildcard ../bin/cc65*),../bin/cc65,cc65)
LD65 := $(if $(wildcard ../bin/ld65*),../bin/ld65,ld65)

export CC65_HOME := $(abspath ..)

define ASSEMBLE_recipe

$(if $(QUIET),,@echo $(TARGET) - $<)
@$(CA65) -t $(TARGET) $(CA65FLAGS) --create-dep $(@:.o=.d) -o $@ $<

endef # ASSEMBLE_recipe

define COMPILE_recipe

$(if $(QUIET),,@echo $(TARGET) - $<)
@$(CC65) -t $(TARGET) $(CC65FLAGS) --create-dep $(@:.o=.d) --dep-target $@ -o $(@:.o=.s) $<
@$(CA65) -t $(TARGET) -o $@ $(@:.o=.s)

endef # COMPILE_recipe

../libwrk/$(TARGET)/%.o: %.s | ../libwrk/$(TARGET)
	$(ASSEMBLE_recipe)

../libwrk/$(TARGET)/%.o: %.c | ../libwrk/$(TARGET)
	$(COMPILE_recipe)

$(EXTRA_OBJPAT): $(EXTRA_SRCPAT) | ../libwrk/$(TARGET) ../lib
	@echo $(TARGET) - $(<F)
	@$(CA65) -t $(TARGET) $(CA65FLAGS) --create-dep $(@:../lib/%.o=../libwrk/$(TARGET)/%.d) -o $@ $<

../lib/$(TARGET).lib: $(OBJS) | ../lib
	$(AR65) a $@ $?

../libwrk/$(TARGET) ../lib ../target/$(TARGET)/util:
	@$(call MKDIR,$@)

$(TARGET): $(EXTRA_OBJS) ../lib/$(TARGET).lib

-include $(DEPS)

endif # TARGET

=== samples/Makefile ===
#
# Makefile for cc65 samples
#
# This Makefile requires GNU make
#

# Run 'make SYS=<target>' or set a SYS env
# var to build for another target system.
SYS ?= c64

ifneq ($(shell echo),)
  CMD_EXE = 1
endif

ifdef CMD_EXE
  NULLDEV = nul:
  DEL = -del /f
  RMDIR = rmdir /s /q
else
  NULLDEV = /dev/null
  DEL = $(RM)
  RMDIR = $(RM) -r
endif

ifdef CC65_HOME
  AS = $(CC65_HOME)/bin/ca65
  CC = $(CC65_HOME)/bin/cc65
  CL = $(CC65_HOME)/bin/cl65
  LD = $(CC65_HOME)/bin/ld65
else
  AS := $(if $(wildcard ../bin/ca65*),../bin/ca65,ca65)
  CC := $(if $(wildcard ../bin/cc65*),../bin/cc65,cc65)
  CL := $(if $(wildcard ../bin/cl65*),../bin/cl65,cl65)
  LD := $(if $(wildcard ../bin/ld65*),../bin/ld65,ld65)
endif

ifneq ($(filter disk samples.%,$(MAKECMDGOALS)),)
  TARGET_PATH := $(shell $(CL) --print-target-path)

  EMD := $(wildcard $(TARGET_PATH)/$(SYS)/drv/emd/*)
  MOU := $(wildcard $(TARGET_PATH)/$(SYS)/drv/mou/*)
  TGI := $(wildcard $(TARGET_PATH)/$(SYS)/drv/tgi/*)

  # This one comes with VICE
  C1541 ?= c1541

  # For this one see https://applecommander.github.io/
  AC ?= ac.jar

  # For this one see http://www.horus.com/~hias/atari/
  DIR2ATR ?= dir2atr

  DISK_c64       = samples.d64
  DISK_apple2    = samples.dsk
  DISK_apple2enh = samples.dsk
  DISK_atari     = samples.atr
  DISK_atarixl   = samples.atr
endif

# --------------------------------------------------------------------------
# System-dependent settings

# The Apple machines need the start address adjusted when using TGI
LDFLAGS_mandelbrot_apple2    = --start-addr 0x4000
LDFLAGS_mandelbrot_apple2enh = --start-addr 0x4000
LDFLAGS_tgidemo_apple2       = --start-addr 0x4000
LDFLAGS_tgidemo_apple2enh    = --start-addr 0x4000

# The Apple ][ needs the start address adjusted for the mousedemo
LDFLAGS_mousedemo_apple2 = --start-addr 0x4000

# The Apple machines need the end address adjusted for large programs
LDFLAGS_gunzip65_apple2    = -D __HIMEM__=0xBF00
LDFLAGS_gunzip65_apple2enh = -D __HIMEM__=0xBF00

# The atari target needs to reserve some memory when using TGI
LDFLAGS_mandelbrot_atari = -D __RESERVED_MEMORY__=0x2000
LDFLAGS_tgidemo_atari    = -D __RESERVED_MEMORY__=0x2000

# The atarixl target needs the start address adjusted when using TGI
LDFLAGS_mandelbrot_atarixl = --start-addr 0x4000
LDFLAGS_tgidemo_atarixl    = --start-addr 0x4000

# --------------------------------------------------------------------------
# Generic rules

.PHONY: all mostlyclean clean install zip samples disk

%: %.c
%: %.s

.c.o:
	$(CC) $(CFLAGS) -Ors --codesize 500 -T -g -t $(SYS) $<
	$(AS) $(<:.c=.s)

.s.o:
	$(AS) $(AFLAGS) -t $(SYS) $<

.PRECIOUS: %.o

.o:
	$(LD) $(LDFLAGS_$(@F)_$(SYS)) -o $@ -t $(SYS) -m $@.map $^ $(SYS).lib

# --------------------------------------------------------------------------
# List of executables

EXELIST_c64 =      \
        ascii      \
        enumdevdir \
        fire       \
        gunzip65   \
        hello      \
        mandelbrot \
        mousedemo  \
        multdemo   \
        nachtm     \
        ovrldemo   \
        plasma     \
        sieve      \
        tgidemo

EXELIST_apple2 =   \
        ascii      \
        diodemo    \
        enumdevdir \
        gunzip65   \
        hello      \
        mandelbrot \
        mousedemo  \
        multdemo   \
        ovrldemo   \
        sieve      \
        tgidemo

EXELIST_apple2enh = $(EXELIST_apple2)

EXELIST_atari =    \
        ascii      \
        gunzip65   \
        hello      \
        mandelbrot \
        mousedemo  \
        multdemo   \
        ovrldemo   \
        sieve      \
        tgidemo

EXELIST_atarixl = $(EXELIST_atari)

EXELIST_atari2600 = \
        atari2600hello

# --------------------------------------------------------------------------
# Rules to make the binaries and the disk

samples: $(EXELIST_$(SYS))

disk: $(DISK_$(SYS))

all:

# --------------------------------------------------------------------------
# Overlay rules. Overlays need special ld65 configuration files.  Also, the
# overlay file-names are shortenned to fit the Atari's 8.3-character limit.

multdemo: multidemo.o
	$(LD) -o $@ -C $(SYS)-overlay.cfg -m $@.map $^ $(SYS).lib

ovrldemo: overlaydemo.o
	$(LD) -o $@ -C $(SYS)-overlay.cfg -m $@.map $^ $(SYS).lib

OVERLAYLIST := $(foreach I,1 2 3,multdemo.$I ovrldemo.$I)

# --------------------------------------------------------------------------
# Rule to make a CBM disk with all samples. Needs the c1541 program that comes
# with the VICE emulator.

define D64_WRITE_recipe

$(C1541) -attach $@ -write $(file) $(notdir $(file)) >$(NULLDEV)

endef # D64_WRITE_recipe

samples.d64: samples
	@$(C1541) -format samples,AA  d64 $@ >$(NULLDEV)
	$(foreach file,$(EXELIST_$(SYS)),$(D64_WRITE_recipe))
	$(foreach file,$(OVERLAYLIST),$(D64_WRITE_recipe))
	$(foreach file,$(EMD) $(MOU) $(TGI),$(D64_WRITE_recipe))

# --------------------------------------------------------------------------
# Rule to make an Apple II disk with all samples. Needs the AppleCommander
# program available at https://applecommander.github.io/ and a template disk
# named 'prodos.dsk'.

define DSK_WRITE_BIN_recipe

$(if $(findstring BF00,$(LDFLAGS_$(notdir $(file))_$(SYS))), \
  java -jar $(AC) -p $@ $(notdir $(file)).system sys <$(TARGET_PATH)/$(SYS)/util/loader.system)
java -jar $(AC) -as $@ $(notdir $(file)) <$(file)

endef # DSK_WRITE_BIN_recipe

define DSK_WRITE_REL_recipe

java -jar $(AC) -p $@ $(notdir $(file)) rel 0 <$(file)

endef # DSK_WRITE_REL_recipe

samples.dsk: samples
	cp prodos.dsk $@
	$(foreach file,$(EXELIST_$(SYS)),$(DSK_WRITE_BIN_recipe))
	$(foreach file,$(OVERLAYLIST),$(DSK_WRITE_REL_recipe))
	$(foreach file,$(EMD) $(MOU) $(TGI),$(DSK_WRITE_REL_recipe))

# --------------------------------------------------------------------------
# Rule to make an Atari disk with all samples. Needs the dir2atr program
# available at http://www.horus.com/~hias/atari/ and the MyDos4534 variant
# of dos.sys and dup.sys.

define ATR_WRITE_recipe

cp $(file) atr/$(notdir $(file))

endef # ATR_WRITE_recipe

samples.atr: samples
	@mkdir atr
	cp dos.sys atr/dos.sys
	cp dup.sys atr/dup.sys
	@$(foreach file,$(EXELIST_$(SYS)),$(ATR_WRITE_recipe))
	@$(foreach file,$(OVERLAYLIST),$(ATR_WRITE_recipe))
	@$(foreach file,$(EMD) $(MOU) $(TGI),$(ATR_WRITE_recipe))
	$(DIR2ATR) -d -b MyDos4534 3200 $@ atr
	@$(RMDIR) atr

# --------------------------------------------------------------------------
# Installation rules

INSTALL = install
samplesdir = $(PREFIX)/share/cc65/samples

install:
	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
	$(INSTALL) -d $(DESTDIR)$(samplesdir)
	$(INSTALL) -d $(DESTDIR)$(samplesdir)/geos
	$(INSTALL) -d $(DESTDIR)$(samplesdir)/tutorial
	$(INSTALL) -m0644 *.* $(DESTDIR)$(samplesdir)
	$(INSTALL) -m0644 README $(DESTDIR)$(samplesdir)
	$(INSTALL) -m0644 Makefile $(DESTDIR)$(samplesdir)
	$(INSTALL) -m0644 geos/*.* $(DESTDIR)$(samplesdir)/geos
	$(INSTALL) -m0644 tutorial/*.* $(DESTDIR)$(samplesdir)/tutorial

# --------------------------------------------------------------------------
# Packaging rules

zip:
	@cd .. && zip -r cc65 samples/

# --------------------------------------------------------------------------
# Clean-up rules

mostlyclean:
	@$(DEL) *.map *.o *.s 2>$(NULLDEV)

clean: mostlyclean
	@$(DEL) $(EXELIST_$(SYS)) $(DISK_$(SYS)) 2>$(NULLDEV)
	@$(DEL) multdemo.? ovrldemo.? 2>$(NULLDEV)

=== src/Makefile ===
ifneq ($(shell echo),)
  CMD_EXE = 1
endif

PROGS = ar65     \
        ca65     \
        cc65     \
        chrcvt65 \
        cl65     \
        co65     \
        da65     \
        grc65    \
        ld65     \
        od65     \
        sim65    \
        sp65

.PHONY: all mostlyclean clean install zip avail unavail bin $(PROGS)

.SUFFIXES:

bindir  := $(PREFIX)/bin
datadir := $(if $(PREFIX),$(PREFIX)/share/cc65,$(abspath ..))

CA65_INC = $(datadir)/asminc
CC65_INC = $(datadir)/include
CL65_TGT = $(datadir)/target
LD65_LIB = $(datadir)/lib
LD65_OBJ = $(datadir)/lib
LD65_CFG = $(datadir)/cfg

ifdef CMD_EXE
  NULLDEV = nul:
  DIRLIST = $(strip $(foreach dir,$1,$(wildcard $(dir))))
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = $(if $(DIRLIST),rmdir /s /q $(subst /,\,$(DIRLIST)))
else
  NULLDEV = /dev/null
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
endif

CC = $(CROSS_COMPILE)gcc
AR = $(CROSS_COMPILE)ar

ifdef CROSS_COMPILE
  $(info CC: $(CC))
  $(info AR: $(AR))
endif

ifdef USER_CFLAGS
  $(info USER_CFLAGS: $(USER_CFLAGS))
endif

ifdef GIT_SHA
  $(info GIT_SHA: $(GIT_SHA))
else
  GIT_SHA := $(shell git rev-parse --short HEAD 2>$(NULLDEV) || svnversion 2>$(NULLDEV))
  ifneq ($(words $(GIT_SHA)),1)
    GIT_SHA := N/A
    $(info GIT_SHA: N/A)
  endif
endif

CFLAGS += -MMD -MP -O3 -I common \
          -Wall -Wextra -Wno-char-subscripts $(USER_CFLAGS) \
          -DCA65_INC=$(CA65_INC) -DCC65_INC=$(CC65_INC) -DCL65_TGT=$(CL65_TGT) \
          -DLD65_LIB=$(LD65_LIB) -DLD65_OBJ=$(LD65_OBJ) -DLD65_CFG=$(LD65_CFG) \
          -DGIT_SHA=$(GIT_SHA)

LDLIBS += -lm

ifdef CMD_EXE
  EXE_SUFFIX=.exe
endif

ifdef CROSS_COMPILE
  EXE_SUFFIX=.exe
endif

all bin: $(PROGS)

mostlyclean:
	$(call RMDIR,../wrk)

clean:
	$(call RMDIR,../wrk ../bin)

ifdef CMD_EXE

install avail unavail:

else # CMD_EXE

INSTALL = install

define AVAIL_recipe

ln -s $(abspath ../bin/$(prog)) /usr/local/bin/$(prog)

endef # AVAIL_recipe

define UNAVAIL_recipe

$(RM) /usr/local/bin/$(prog)

endef # UNAVAIL_recipe

install:
	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) ../bin/* $(DESTDIR)$(bindir)

avail:
	$(foreach prog,$(PROGS),$(AVAIL_recipe))

unavail:
	$(foreach prog,$(PROGS),$(UNAVAIL_recipe))

endif # CMD_EXE

zip:
	@cd .. && zip cc65 bin/*

define OBJS_template

$1_OBJS := $$(patsubst %.c,../wrk/%.o,$$(wildcard $1/*.c))

$$($1_OBJS): | ../wrk/$1

../wrk/$1:
	@$$(call MKDIR,$$@)

DEPS += $$($1_OBJS:.o=.d)

endef # OBJS_template

define PROG_template

$$(eval $$(call OBJS_template,$1))

../bin/$1$(EXE_SUFFIX): $$($1_OBJS) ../wrk/common/common.a | ../bin
	$$(CC) $$(LDFLAGS) -o $$@ $$^ $$(LDLIBS)

$1: ../bin/$1$(EXE_SUFFIX)

endef # PROG_template

../wrk/%.o: %.c
	@echo $<
	@$(CC) -c $(CFLAGS) -o $@ $<

../bin:
	@$(call MKDIR,$@)

$(eval $(call OBJS_template,common))

../wrk/common/common.a: $(common_OBJS)
	$(AR) r $@ $?

$(foreach prog,$(PROGS),$(eval $(call PROG_template,$(prog))))

-include $(DEPS)

=== test/misc/Makefile ===
# Makefile for the remaining tests that need special care in one way or another

ifneq ($(shell echo),)
  CMD_EXE = 1
endif

ifdef CMD_EXE
  S = $(subst /,\,/)
  NOT = - # Hack
  EXE = .exe
  NULLDEV = nul:
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = -rmdir /s /q $(subst /,\,$1)
  DEL = del /f $(subst /,\,$1)
else
  S = /
  NOT = !
  EXE =
  NULLDEV = /dev/null
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
  DEL = $(RM) $1
endif

ifdef QUIET
  .SILENT:
  NULLOUT = >$(NULLDEV)
  NULLERR = 2>$(NULLDEV)
endif

SIM65FLAGS = -x 200000000

CL65 := $(if $(wildcard ../../bin/cl65*),..$S..$Sbin$Scl65,cl65)
SIM65 := $(if $(wildcard ../../bin/sim65*),..$S..$Sbin$Ssim65,sim65)

WORKDIR = ..$S..$Stestwrk$Smisc

OPTIONS = g O Os Osi Osir Osr Oi Oir Or

DIFF = $(WORKDIR)$Sbdiff$(EXE)

CC = gcc
CFLAGS = -O2

.PHONY: all clean

SOURCES := $(wildcard *.c)
TESTS  = $(foreach option,$(OPTIONS),$(SOURCES:%.c=$(WORKDIR)/%.$(option).6502.prg))
TESTS += $(foreach option,$(OPTIONS),$(SOURCES:%.c=$(WORKDIR)/%.$(option).65c02.prg))

all: $(TESTS)

$(WORKDIR):
	$(call MKDIR,$(WORKDIR))

$(DIFF): ../bdiff.c | $(WORKDIR)
	$(CC) $(CFLAGS) -o $@ $<

define PRG_template

# should compile, but then hangs in an endless loop
$(WORKDIR)/endless.$1.$2.prg: endless.c | $(WORKDIR)
	$(if $(QUIET),echo misc/endless.$1.$2.prg)
	$(CL65) -t sim$2 -$1 -o $$@ $$< $(NULLERR)
	$(NOT) $(SIM65) $(SIM65FLAGS) $$@ $(NULLOUT) $(NULLERR)

# these need reference data that can't be generated by a host-compiled program,
# in a useful way
$(WORKDIR)/limits.$1.$2.prg: limits.c $(DIFF)
	$(if $(QUIET),echo misc/limits.$1.$2.prg)
	$(CL65) -t sim$2 -$1 -o $$@ $$< $(NULLERR)
	$(SIM65) $(SIM65FLAGS) $$@ > $(WORKDIR)/limits.$1.out
	$(DIFF) $(WORKDIR)/limits.$1.out limits.ref

# the rest are tests that fail currently for one reason or another
$(WORKDIR)/fields.$1.$2.prg: fields.c | $(WORKDIR)
	@echo "FIXME: " $$@ "currently will fail."
	$(CL65) -t sim$2 -$1 -o $$@ $$< $(NULLERR)
	-$(SIM65) $(SIM65FLAGS) $$@ $(NULLOUT)
$(WORKDIR)/sitest.$1.$2.prg: sitest.c | $(WORKDIR)
	@echo "FIXME: " $$@ "currently will fail."
	-$(CL65) -t sim$2 -$1 -o $$@ $$< $(NULLERR)
#	-$(SIM65) $(SIM65FLAGS) $$@ $(NULLOUT)
$(WORKDIR)/cc65141011.$1.$2.prg: cc65141011.c | $(WORKDIR)
	@echo "FIXME: " $$@ "currently can fail."
	$(CL65) -t sim$2 -$1 -o $$@ $$< $(NULLERR)
	-$(SIM65) $(SIM65FLAGS) $$@ $(NULLOUT)

endef # PRG_template

$(foreach option,$(OPTIONS),$(eval $(call PRG_template,$(option),6502)))
$(foreach option,$(OPTIONS),$(eval $(call PRG_template,$(option),65c02)))

clean:
	@$(call RMDIR,$(WORKDIR))
	@$(call DEL,$(SOURCES:.c=.o))

=== test/ref/Makefile ===
# Makefile for the regression tests that generate output which has to be
# compared with reference output

ifneq ($(shell echo),)
  CMD_EXE = 1
endif

ifdef CMD_EXE
  S = $(subst /,\,/)
  EXE = .exe
  NULLDEV = nul:
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = -rmdir /s /q $(subst /,\,$1)
  DEL = del /f $(subst /,\,$1)
else
  S = /
  EXE =
  NULLDEV = /dev/null
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
  DEL = $(RM) $1
endif

ifdef QUIET
  .SILENT:
  NULLERR = 2>$(NULLDEV)
endif

SIM65FLAGS = -x 200000000

CL65 := $(if $(wildcard ../../bin/cl65*),..$S..$Sbin$Scl65,cl65)
SIM65 := $(if $(wildcard ../../bin/sim65*),..$S..$Sbin$Ssim65,sim65)

WORKDIR = ..$S..$Stestwrk$Sref

OPTIONS = g O Os Osi Osir Osr Oi Oir Or

DIFF = $(WORKDIR)$Sbdiff$(EXE)

CC = gcc
CFLAGS = -O2 -Wall -W -Wextra -funsigned-char -fwrapv -fno-strict-overflow

.PHONY: all clean

SOURCES := $(wildcard *.c)
REFS = $(SOURCES:%.c=$(WORKDIR)/%.ref)
TESTS  = $(foreach option,$(OPTIONS),$(SOURCES:%.c=$(WORKDIR)/%.$(option).6502.prg))
TESTS += $(foreach option,$(OPTIONS),$(SOURCES:%.c=$(WORKDIR)/%.$(option).65c02.prg))

all: $(REFS) $(TESTS)

$(WORKDIR):
	$(call MKDIR,$(WORKDIR))

$(WORKDIR)/%.ref: %.c | $(WORKDIR)
	$(if $(QUIET),echo ref/$*.host)
	$(CC) $(CFLAGS) -o $(WORKDIR)/$*.host $< $(NULLERR)
	$(WORKDIR)$S$*.host > $@

$(DIFF): ../bdiff.c | $(WORKDIR)
	$(CC) $(CFLAGS) -o $@ $<

# Some files have "K & R"-style syntax.  Therefore, some forward
# function-declarations don't match the later function definitions.
# Those programs fail when fastcall is used; but, the cdecl calling convention
# tolerates those conflicts.  Therefore, make their functions default to cdecl.
#
$(WORKDIR)/init.%.prg   \
$(WORKDIR)/switch.%.prg \
$(WORKDIR)/yacc.%.prg   \
$(WORKDIR)/yaccdbg.%.prg: CC65FLAGS += -Wc --all-cdecl

# "yaccdbg.c" includes "yacc.c".
# yaccdbg's built files must depend on both of them.
#
$(WORKDIR)/yaccdbg.ref:   yacc.c
$(WORKDIR)/yaccdbg.%.prg: yacc.c

define PRG_template

$(WORKDIR)/%.$1.$2.prg: %.c $(WORKDIR)/%.ref $(DIFF)
	$(if $(QUIET),echo ref/$$*.$1.$2.prg)
	$(CL65) -t sim$2 $$(CC65FLAGS) -$1 -o $$@ $$< $(NULLERR)
	$(SIM65) $(SIM65FLAGS) $$@ > $(WORKDIR)/$$*.out
	$(DIFF) $(WORKDIR)/$$*.out $(WORKDIR)/$$*.ref

endef # PRG_template

$(foreach option,$(OPTIONS),$(eval $(call PRG_template,$(option),6502)))
$(foreach option,$(OPTIONS),$(eval $(call PRG_template,$(option),65c02)))

clean:
	@$(call RMDIR,$(WORKDIR))
	@$(call DEL,$(SOURCES:.c=.o))

=== test/val/Makefile ===
# Makefile for the regression tests that return an error code on failure

ifneq ($(shell echo),)
  CMD_EXE = 1
endif

ifdef CMD_EXE
  S = $(subst /,\,/)
  NULLDEV = nul:
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = -rmdir /s /q $(subst /,\,$1)
  DEL = del /f $(subst /,\,$1)
else
  S = /
  NULLDEV = /dev/null
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
  DEL = $(RM) $1
endif

ifdef QUIET
  .SILENT:
  NULLOUT = >$(NULLDEV)
  NULLERR = 2>$(NULLDEV)
endif

SIM65FLAGS = -x 200000000

CL65 := $(if $(wildcard ../../bin/cl65*),..$S..$Sbin$Scl65,cl65)
SIM65 := $(if $(wildcard ../../bin/sim65*),..$S..$Sbin$Ssim65,sim65)

WORKDIR = ../../testwrk/val

OPTIONS = g O Os Osi Osir Osr Oi Oir Or

.PHONY: all clean

SOURCES := $(wildcard *.c)
TESTS  = $(foreach option,$(OPTIONS),$(SOURCES:%.c=$(WORKDIR)/%.$(option).6502.prg))
TESTS += $(foreach option,$(OPTIONS),$(SOURCES:%.c=$(WORKDIR)/%.$(option).65c02.prg))

all: $(TESTS)

$(WORKDIR):
	$(call MKDIR,$(WORKDIR))

# Some files have "K & R"-style syntax.  Therefore, some forward
# function-declarations don't match the later function definitions.
# Those programs fail when fastcall is used; but, the cdecl calling convention
# tolerates those conflicts.  Therefore, make their functions default to cdecl.
#
$(WORKDIR)/cq4.%.prg  \
$(WORKDIR)/cq71.%.prg \
$(WORKDIR)/cq81.%.prg \
$(WORKDIR)/cq84.%.prg: CC65FLAGS += -Wc --all-cdecl

define PRG_template

$(WORKDIR)/%.$1.$2.prg: %.c | $(WORKDIR)
	$(if $(QUIET),echo val/$$*.$1.$2.prg)
	$(CL65) -t sim$2 $$(CC65FLAGS) -$1 -o $$@ $$< $(NULLERR)
	$(SIM65) $(SIM65FLAGS) $$@ $(NULLOUT)

endef # PRG_template

$(foreach option,$(OPTIONS),$(eval $(call PRG_template,$(option),6502)))
$(foreach option,$(OPTIONS),$(eval $(call PRG_template,$(option),65c02)))

clean:
	@$(call RMDIR,$(WORKDIR))
	@$(call DEL,$(SOURCES:.c=.o))

=== testcode/lib/apple2/Makefile ===
# For this one see https://applecommander.github.io/
AC ?= ac.jar

CL      = cl65
CLFLAGS = -t apple2 -C apple2-hgr.cfg -Oirs

hgrtest.dsk: hgrtest
	cp prodos.dsk $@
	java -jar $(AC) -cc65 $@ hgrtest bin <hgrtest

hgrtest: hgrtest.c werner.s
	$(CL) $(CLFLAGS) -m hgrtest.map $^

=== debian/changelog ===
cc65 (2.17-1) unstable; urgency=medium

  * New upstream release.
  * Update debhelper level to 11:
    - don't specify parallel to debhelper.
  * Update Standards-Version to 4.1.3 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 10 Mar 2018 18:02:01 +0000

=== debian/control ===
Source: cc65
Section: otherosfs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper (>= 11), linuxdoc-tools
Standards-Version: 4.1.3
Homepage: https://cc65.github.io/cc65/

Package: cc65
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: cc65-doc
Description: complete cross development package for 65(C)02 systems
 cc65 is a complete cross development package for 65(C)02 systems, including
 a powerful macro assembler, a C compiler, linker, librarian and several
 other tools.
 .
 cc65 has C and runtime library support for many of the old 6502 machines,
 including
   - the following Commodore machines:
     - VIC20
     - C16/C116 and Plus/4
     - C64
     - C128
     - CBM 510 (aka P500)
     - the 600/700 family
     - newer PET machines (not 2001).
  - the Apple ][+ and successors.
  - the Atari 8 bit machines.
  - the Atari 5200 console.
  - GEOS for the C64, C128 and Apple //e.
  - the Nintendo Entertainment System (NES) console.
  - the Supervision console.
  - the Oric Atmos.
  - the Lynx console.
  - the Ohio Scientific Challenger 1P

Package: cc65-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: cc65 documentation
 cc65 is a complete cross development package for 65(C)02 systems, including
 a powerful macro assembler, a C compiler, linker, librarian and several
 other tools.
 .
 This package contains the documentation that is also available on
 the cc65 homepage.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr PKG_VERSION="$(DEB_VENDOR) $(DEB_VERSION)"
	$(MAKE) -C doc html

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

%:
	dh $@

.PHONY: override_dh_auto_build override_dh_auto_install

## cc65 2.18

=== libsrc/Makefile ===
--- 
+++ 
@@ -93,7 +93,7 @@
 
 define INSTALL_recipe
 
-$(if $(PREFIX),,$(error variable `PREFIX' must be set))
+$(if $(PREFIX),,$(error variable "PREFIX" must be set))
 $(INSTALL) -d $(DESTDIR)$(datadir)/$(dir)
 $(INSTALL) -m0644 ../$(dir)/*.* $(DESTDIR)$(datadir)/$(dir)

=== samples/Makefile ===
--- 
+++ 
@@ -4,10 +4,17 @@
 # This Makefile requires GNU make
 #
 
-# Run 'make SYS=<target>' or set a SYS env
-# var to build for another target system.
+# Run 'make SYS=<target>'; or, set a SYS env.
+# var. to build for another target system.
 SYS ?= c64
 
+# Just the usual way to define a variable
+# containing a single space character.
+SPACE :=
+SPACE +=
+
+# Just the usual way to find out if we're
+# using cmd.exe to execute make rules.
 ifneq ($(shell echo),)
   CMD_EXE = 1
 endif
@@ -35,19 +42,55 @@
 endif
 
 ifneq ($(filter disk samples.%,$(MAKECMDGOALS)),)
-  TARGET_PATH := $(shell $(CL) --print-target-path)
+  ifdef CC65_HOME
+    TARGET_PATH = $(CC65_HOME)/target
+  else
+    TARGET_PATH := $(if $(wildcard ../target),../target,$(shell $(CL) --print-target-path))
+  endif
+
+  # If TARGET_PATH contains spaces then it is presumed to contain escaped spaces. GNU make
+  # has very limited support for paths containing spaces. $(wildcard) is the only function
+  # that is aware of escaped spaces. However, $(wildcard) never returns paths with escaped
+  # spaces !!! So if it e.g. finds 4 files in a path with 2 spaces then one ends up with a
+  # return value consisting of 12 plain words :-((
+  #
+  # Fortunately we can work around that behaviour here because we know that the files we
+  # are looking for have known extensions. So we can $(filter) the in our example above 12
+  # words for file extensions so we come up with 4 path fragments. Then we remove those
+  # path fragments with $(notdir) from the file names.
+  #
+  # So far so good. But here we want to process files from different paths in a single
+  # recipe further down below and therefore want to prepend the paths to the files with
+  # $(addprefix). However, $(foreach) isn't aware of escaped spaces (only $(wildcard) is).
+  # Therefore, we need to replace the spaces with some other character temporarily in order
+  # to have $(foreach) generate one invocation per file. We use the character '?' for that
+  # purpose here, just because it is known to not be part of file names.
+  #
+  # Inside the recipe generated per file we then replace the '?' again with a space. As we
+  # want to be compatible with cmd.exe for execution we're not using an escaped space but
+  # rather double-quote the whole path.
+  #
+  # Note: The "strange" $(wildcard) further down below just serves the purpose to unescape
+  #       spaces for cmd.exe. This could have as well been done with another $(subst).
+
+  SUBST_TARGET_PATH := $(subst \$(SPACE),?,$(TARGET_PATH))
 
   EMD := $(wildcard $(TARGET_PATH)/$(SYS)/drv/emd/*)
   MOU := $(wildcard $(TARGET_PATH)/$(SYS)/drv/mou/*)
   TGI := $(wildcard $(TARGET_PATH)/$(SYS)/drv/tgi/*)
 
-  # This one comes with VICE
+  EMD := $(addprefix $(SUBST_TARGET_PATH)/$(SYS)/drv/emd/,$(notdir $(filter %.emd,$(EMD))))
+  MOU := $(addprefix $(SUBST_TARGET_PATH)/$(SYS)/drv/mou/,$(notdir $(filter %.mou,$(MOU))))
+  TGI := $(addprefix $(SUBST_TARGET_PATH)/$(SYS)/drv/tgi/,$(notdir $(filter %.tgi,$(TGI))))
+
+  # This one comes with the VICE emulator.
+  # See http://vice-emu.sourceforge.net/
   C1541 ?= c1541
 
-  # For this one see https://applecommander.github.io/
+  # For this one, see https://applecommander.github.io/
   AC ?= ac.jar
 
-  # For this one see http://www.horus.com/~hias/atari/
+  # For this one, see http://www.horus.com/~hias/atari/
   DIR2ATR ?= dir2atr
 
   DISK_c64       = samples.d64
@@ -59,6 +102,8 @@
 
 # --------------------------------------------------------------------------
 # System-dependent settings
+# For convenience, these groups and lines are sorted alphabetically, first
+# by target-machine group, then by mission, then by program and sub-target.
 
 # The Apple machines need the start address adjusted when using TGI
 LDFLAGS_mandelbrot_apple2    = --start-addr 0x4000
@@ -94,15 +139,19 @@
 	$(AS) $(<:.c=.s)
 
 .s.o:
-	$(AS) $(AFLAGS) -t $(SYS) $<
+	$(AS) $(ASFLAGS) -t $(SYS) $<
 
 .PRECIOUS: %.o
 
 .o:
-	$(LD) $(LDFLAGS_$(@F)_$(SYS)) -o $@ -t $(SYS) -m $@.map $^ $(SYS).lib
-
-# --------------------------------------------------------------------------
-# List of executables
+ifeq ($(SYS),vic20)
+	$(LD) $(LDFLAGS_$(@F)_$(SYS)) $(LDFLAGS) -o $@ -C vic20-32k.cfg -m $@.map $^ $(SYS).lib
+else
+	$(LD) $(LDFLAGS_$(@F)_$(SYS)) $(LDFLAGS) -o $@ -t $(SYS) -m $@.map $^ $(SYS).lib
+endif
+
+# --------------------------------------------------------------------------
+# Lists of executables
 
 EXELIST_c64 =      \
         ascii      \
@@ -150,6 +199,13 @@
 EXELIST_atari2600 = \
         atari2600hello
 
+# Unlisted targets will try to build everything.
+# That lets us learn what they cannot build, and what settings
+# we need to use for programs that can be built and run.
+ifndef EXELIST_$(SYS)
+EXELIST_$(SYS) := ${patsubst %.c,%,$(wildcard *.c)}
+endif
+
 # --------------------------------------------------------------------------
 # Rules to make the binaries and the disk
 
@@ -164,10 +220,10 @@
 # overlay file-names are shortenned to fit the Atari's 8.3-character limit.
 
 multdemo: multidemo.o
-	$(LD) -o $@ -C $(SYS)-overlay.cfg -m $@.map $^ $(SYS).lib
+	$(LD) $(LDFLAGS) -o $@ -C $(SYS)-overlay.cfg -m $@.map $^ $(SYS).lib
 
 ovrldemo: overlaydemo.o
-	$(LD) -o $@ -C $(SYS)-overlay.cfg -m $@.map $^ $(SYS).lib
+	$(LD) $(LDFLAGS) -o $@ -C $(SYS)-overlay.cfg -m $@.map $^ $(SYS).lib
 
 OVERLAYLIST := $(foreach I,1 2 3,multdemo.$I ovrldemo.$I)
 
@@ -177,32 +233,32 @@
 
 define D64_WRITE_recipe
 
-$(C1541) -attach $@ -write $(file) $(notdir $(file)) >$(NULLDEV)
+$(C1541) -attach $@ -write "$(subst ?,$(SPACE),$(file))" $(notdir $(file)) >$(NULLDEV)
 
 endef # D64_WRITE_recipe
 
 samples.d64: samples
-	@$(C1541) -format samples,AA  d64 $@ >$(NULLDEV)
+	@$(C1541) -format samples,AA d64 $@ >$(NULLDEV)
 	$(foreach file,$(EXELIST_$(SYS)),$(D64_WRITE_recipe))
 	$(foreach file,$(OVERLAYLIST),$(D64_WRITE_recipe))
 	$(foreach file,$(EMD) $(MOU) $(TGI),$(D64_WRITE_recipe))
 
 # --------------------------------------------------------------------------
 # Rule to make an Apple II disk with all samples. Needs the AppleCommander
-# program available at https://applecommander.github.io/ and a template disk
+# program, available at https://applecommander.github.io/, and a template disk
 # named 'prodos.dsk'.
 
 define DSK_WRITE_BIN_recipe
 
 $(if $(findstring BF00,$(LDFLAGS_$(notdir $(file))_$(SYS))), \
-  java -jar $(AC) -p $@ $(notdir $(file)).system sys <$(TARGET_PATH)/$(SYS)/util/loader.system)
-java -jar $(AC) -as $@ $(notdir $(file)) <$(file)
+  java -jar $(AC) -p $@ $(notdir $(file)).system sys <"$(wildcard $(TARGET_PATH)/$(SYS)/util/loader.system)")
+java -jar $(AC) -as $@ $(notdir $(file)) <"$(file)"
 
 endef # DSK_WRITE_BIN_recipe
 
 define DSK_WRITE_REL_recipe
 
-java -jar $(AC) -p $@ $(notdir $(file)) rel 0 <$(file)
+java -jar $(AC) -p $@ $(notdir $(file)) rel 0 <"$(subst ?,$(SPACE),$(file))"
 
 endef # DSK_WRITE_REL_recipe
 
@@ -219,14 +275,14 @@
 
 define ATR_WRITE_recipe
 
-cp $(file) atr/$(notdir $(file))
+cp "$(subst ?,$(SPACE),$(file))" atr/$(notdir $(file))
 
 endef # ATR_WRITE_recipe
 
 samples.atr: samples
 	@mkdir atr
-	cp dos.sys atr/dos.sys
-	cp dup.sys atr/dup.sys
+	cp "dos.sys" atr/dos.sys
+	cp "dup.sys" atr/dup.sys
 	@$(foreach file,$(EXELIST_$(SYS)),$(ATR_WRITE_recipe))
 	@$(foreach file,$(OVERLAYLIST),$(ATR_WRITE_recipe))
 	@$(foreach file,$(EMD) $(MOU) $(TGI),$(ATR_WRITE_recipe))
@@ -240,7 +296,7 @@
 samplesdir = $(PREFIX)/share/cc65/samples
 
 install:
-	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
+	$(if $(PREFIX),,$(error variable "PREFIX" must be set))
 	$(INSTALL) -d $(DESTDIR)$(samplesdir)
 	$(INSTALL) -d $(DESTDIR)$(samplesdir)/geos
 	$(INSTALL) -d $(DESTDIR)$(samplesdir)/tutorial
@@ -260,7 +316,7 @@
 # Clean-up rules
 
 mostlyclean:
-	@$(DEL) *.map *.o *.s 2>$(NULLDEV)
+	@$(DEL) *.lbl *.map *.o *.s 2>$(NULLDEV)
 
 clean: mostlyclean
 	@$(DEL) $(EXELIST_$(SYS)) $(DISK_$(SYS)) 2>$(NULLDEV)

=== src/Makefile ===
--- 
+++ 
@@ -64,8 +64,8 @@
 
 CFLAGS += -MMD -MP -O3 -I common \
           -Wall -Wextra -Wno-char-subscripts $(USER_CFLAGS) \
-          -DCA65_INC=$(CA65_INC) -DCC65_INC=$(CC65_INC) -DCL65_TGT=$(CL65_TGT) \
-          -DLD65_LIB=$(LD65_LIB) -DLD65_OBJ=$(LD65_OBJ) -DLD65_CFG=$(LD65_CFG) \
+          -DCA65_INC="$(CA65_INC)" -DCC65_INC="$(CC65_INC)" -DCL65_TGT="$(CL65_TGT)" \
+          -DLD65_LIB="$(LD65_LIB)" -DLD65_OBJ="$(LD65_OBJ)" -DLD65_CFG="$(LD65_CFG)" \
           -DGIT_SHA=$(GIT_SHA)
 
 LDLIBS += -lm
@@ -107,7 +107,7 @@
 endef # UNAVAIL_recipe
 
 install:
-	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
+	$(if $(PREFIX),,$(error variable "PREFIX" must be set))
 	$(INSTALL) -d $(DESTDIR)$(bindir)
 	$(INSTALL) ../bin/* $(DESTDIR)$(bindir)

=== testcode/lib/accelerator/Makefile ===
CL ?= cl65

all:	c64-scpu-test.prg c128-scpu-test.prg c64dtv-test.prg \
	c64-c128-test.prg c128-test.prg chameleon-test.prg \
	c65-test.prg turbomaster-test.prg

c64-scpu-test.prg: c64-c128-scpu-test.c
	$(CL) -t c64 c64-c128-scpu-test.c -o c64-scpu-test.prg

c128-scpu-test.prg: c64-c128-scpu-test.c
	$(CL) -t c128 c64-c128-scpu-test.c -o c128-scpu-test.prg

c64dtv-test.prg: c64dtv-test.c
	$(CL) -t c64 c64dtv-test.c -o c64dtv-test.prg

c64-c128-test.prg: c64-c128-test.c
	$(CL) -t c64 c64-c128-test.c -o c64-c128-test.prg

c128-test.prg: c64-c128-test.c
	$(CL) -t c128 c64-c128-test.c -o c128-test.prg

chameleon-test.prg: chameleon-test.c
	$(CL) -t c64 chameleon-test.c -o chameleon-test.prg

c65-test.prg: c65-test.c
	$(CL) -t c64 c65-test.c -o c65-test.prg

turbomaster-test.prg: turbomaster-test.c
	$(CL) -t c64 turbomaster-test.c -o turbomaster-test.prg

=== testcode/lib/apple2/Makefile ===
# For this one see https://applecommander.github.io/
AC ?= ac.jar

CL ?= cl65

all: hgr.dsk dhgr.dsk

hgr.dsk: hgrshow hgrtest
	cp prodos.dsk $@
	java -jar $(AC) -as $@ hgrshow <hgrshow
	java -jar $(AC) -as $@ hgrtest <hgrtest
	java -jar $(AC) -p  $@ astronaut.hgr  bin 0x2000 <astronaut.hgr
	java -jar $(AC) -p  $@ chips.hgr      bin 0x2000 <chips.hgr
	java -jar $(AC) -p  $@ macrometer.hgr bin 0x2000 <macrometer.hgr
	java -jar $(AC) -p  $@ mariner.hgr    bin 0x2000 <mariner.hgr
	java -jar $(AC) -p  $@ rose.hgr       bin 0x2000 <rose.hgr
	java -jar $(AC) -p  $@ werner.hgr     bin 0x2000 <werner.hgr
	java -jar $(AC) -p  $@ winston.hgr    bin 0x2000 <winston.hgr

hgrshow: hgrshow.c
	$(CL) -Oirs -t apple2 --start-addr 0x4000 -m hgrshow.map $^

hgrtest: hgrtest.c werner.s
	$(CL) -Oirs -t apple2 -C apple2-hgr.cfg -m hgrtest.map $^

dhgr.dsk: dhgrshow
	cp prodos.dsk $@
	java -jar $(AC) -as $@ dhgrshow <dhgrshow
	java -jar $(AC) -p  $@ catface.dhgr  bin 0x2000 <catface.dhgr
	java -jar $(AC) -p  $@ gatsby.dhgr   bin 0x2000 <gatsby.dhgr
	java -jar $(AC) -p  $@ girl.dhgr     bin 0x2000 <girl.dhgr
	java -jar $(AC) -p  $@ monarch.dhgr  bin 0x2000 <monarch.dhgr
	java -jar $(AC) -p  $@ superman.dhgr bin 0x2000 <superman.dhgr
	java -jar $(AC) -p  $@ venice.dhgr   bin 0x2000 <venice.dhgr

dhgrshow: dhgrshow.c
	$(CL) -Oirs -t apple2enh --start-addr 0x4000 -m dhgrshow.map $^

=== testcode/lib/pce/Makefile ===
.PHONY: all clean test

# Size of cartridge to generate.
# Possible values:
#  8K = 0x2000
# 16K = 0x4000
# 32K = 0x8000
CARTSIZE := 0x2000

ifeq (${CARTSIZE},0x8000)
COUNT := 3
else
COUNT := 1
endif

all: conio.pce

%.pce: %.bin
	dd if=$< bs=8K skip=${COUNT} > $@
	dd if=$< bs=8K count=${COUNT} >> $@

%.bin: %.c ../../../lib/pce.lib
	../../../bin/cl65 -t pce $< -Wl -D__CARTSIZE__=${CARTSIZE} -m $*.map -o $@

clean:
	$(RM) conio.o conio.???

test: conio.pce
	mednafen -force_module pce $<

=== debian/changelog ===
cc65 (2.18-1) unstable; urgency=medium

  * New upstream release.
  * Disable parallel building (closes: #883353).
  * Add watch file.
  * Update Standards-Version to 4.4.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 09 Nov 2019 20:23:26 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 11), linuxdoc-tools
-Standards-Version: 4.1.3
+Standards-Version: 4.4.1
 Homepage: https://cc65.github.io/cc65/
 
 Package: cc65

## cc65 2.19

=== Makefile ===
.PHONY: all mostlyclean clean install zip avail unavail bin lib doc html info samples

.SUFFIXES:

all mostlyclean clean install zip:
	@$(MAKE) -C src     --no-print-directory $@
	@$(MAKE) -C libsrc  --no-print-directory $@
	@$(MAKE) -C doc     --no-print-directory $@
	@$(MAKE) -C samples --no-print-directory $@

avail unavail bin:
	@$(MAKE) -C src     --no-print-directory $@

lib:
	@$(MAKE) -C libsrc  --no-print-directory $@

doc html info:
	@$(MAKE) -C doc     --no-print-directory $@

samples:
	@$(MAKE) -C samples --no-print-directory $@

%65:
	@$(MAKE) -C src     --no-print-directory $@

%:
	@$(MAKE) -C libsrc  --no-print-directory $@

=== doc/Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 	$(RM) -r ../html ../info
 
 install:
-	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
+	$(if $(PREFIX),,$(error variable "PREFIX" must be set))
 ifeq ($(wildcard ../html),../html)
 	$(INSTALL) -d $(DESTDIR)$(htmldir)
 	$(INSTALL) -m0644 ../html/*.* $(DESTDIR)$(htmldir)

=== libsrc/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
        c64    \
        cbm510 \
        cbm610 \
+       cx16   \
        pet    \
        plus4  \
        vic20

=== src/Makefile ===
--- 
+++ 
@@ -52,21 +52,19 @@
   $(info USER_CFLAGS: $(USER_CFLAGS))
 endif
 
-ifdef GIT_SHA
-  $(info GIT_SHA: $(GIT_SHA))
-else
-  GIT_SHA := $(shell git rev-parse --short HEAD 2>$(NULLDEV) || svnversion 2>$(NULLDEV))
-  ifneq ($(words $(GIT_SHA)),1)
-    GIT_SHA := N/A
-    $(info GIT_SHA: N/A)
+ifndef BUILD_ID
+  BUILD_ID := Git $(shell git rev-parse --short HEAD 2>$(NULLDEV) || svnversion 2>$(NULLDEV))
+  ifneq ($(words $(BUILD_ID)),2)
+    BUILD_ID := N/A
   endif
 endif
+$(info BUILD_ID: $(BUILD_ID))
 
 CFLAGS += -MMD -MP -O3 -I common \
           -Wall -Wextra -Wno-char-subscripts $(USER_CFLAGS) \
           -DCA65_INC="$(CA65_INC)" -DCC65_INC="$(CC65_INC)" -DCL65_TGT="$(CL65_TGT)" \
           -DLD65_LIB="$(LD65_LIB)" -DLD65_OBJ="$(LD65_OBJ)" -DLD65_CFG="$(LD65_CFG)" \
-          -DGIT_SHA=$(GIT_SHA)
+          -DBUILD_ID="$(BUILD_ID)"
 
 LDLIBS += -lm

=== test/dasm/Makefile ===
# Makefile for the disassembler regression tests

ifneq ($(shell echo),)
  CMD_EXE = 1
endif

ifdef CMD_EXE
  EXE = .exe
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = -rmdir /s /q $(subst /,\,$1)
  DEL = del /f $(subst /,\,$1)
else
  EXE =
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
  DEL = $(RM) $1
endif

ifdef QUIET
  .SILENT:
endif

CL65 := $(if $(wildcard ../../bin/cl65*),../../bin/cl65,cl65)
DA65 := $(if $(wildcard ../../bin/da65*),../../bin/da65,da65)

WORKDIR = ../../testwrk/dasm

DIFF = $(WORKDIR)/bdiff$(EXE)

CC = gcc
CFLAGS = -O2

START = --start-addr 0x8000

.PHONY: all clean

SOURCES := $(wildcard *.s)
CPUS = $(foreach src,$(SOURCES),$(src:%-disass.s=%))
BINS = $(foreach cpu,$(CPUS),$(WORKDIR)/$(cpu)-reass.bin)

# default target defined later
all: $(BINS)

$(WORKDIR):
	$(call MKDIR,$(WORKDIR))

$(DIFF): ../bdiff.c | $(WORKDIR)
	$(CC) $(CFLAGS) -o $@ $<

define DISASS_template

$(WORKDIR)/$1-disass.bin: $1-disass.s | $(WORKDIR)
	$(CL65) --cpu $1 -t none $(START) -o $$@ $$<

$(WORKDIR)/$1-reass.s: $(WORKDIR)/$1-disass.bin
	$(DA65) --cpu $1 $(START) -o $$@ $$<

$(WORKDIR)/$1-reass.bin: $(WORKDIR)/$1-reass.s $(DIFF)
	$(if $(QUIET),echo dasm/$1-reass.bin)
	$(CL65) --cpu $1 -t none $(START) -o $$@ $$<
	$(DIFF) $$@ $(WORKDIR)/$1-disass.bin

endef # DISASS_template

$(foreach cpu,$(CPUS),$(eval $(call DISASS_template,$(cpu))))

clean:
	@$(call RMDIR,$(WORKDIR))
	@$(call DEL,$(SOURCES:.s=.o))

=== test/err/Makefile ===
# Makefile for the tests that MUST NOT compile

ifneq ($(shell echo),)
  CMD_EXE = 1
endif

ifdef CMD_EXE
  S = $(subst /,\,/)
  NOT = - # Hack
  NULLDEV = nul:
  MKDIR = mkdir $(subst /,\,$1)
  RMDIR = -rmdir /s /q $(subst /,\,$1)
else
  S = /
  NOT = !
  NULLDEV = /dev/null
  MKDIR = mkdir -p $1
  RMDIR = $(RM) -r $1
endif

ifdef QUIET
  .SILENT:
  NULLERR = 2>$(NULLDEV)
endif

CC65 := $(if $(wildcard ../../bin/cc65*),..$S..$Sbin$Scc65,cc65)

WORKDIR = ../../testwrk/err

.PHONY: all clean

SOURCES := $(wildcard *.c)
TESTS = $(patsubst %.c,$(WORKDIR)/%.s,$(SOURCES))

all: $(TESTS)

$(WORKDIR)/%.s: %.c
	$(if $(QUIET),echo err/$*.s)
	$(NOT) $(CC65) -o $@ $< $(NULLERR)

clean:
	@$(call RMDIR,$(WORKDIR))

=== test/misc/Makefile ===
--- 
+++ 
@@ -72,6 +72,11 @@
 	$(SIM65) $(SIM65FLAGS) $$@ > $(WORKDIR)/limits.$1.out
 	$(DIFF) $(WORKDIR)/limits.$1.out limits.ref
 
+$(WORKDIR)/goto.$1.$2.prg: goto.c $(DIFF)
+	$(if $(QUIET),echo misc/goto.$1.$2.prg)
+	$(CL65) -t sim$2 -$1 -o $$@ $$< 2>$(WORKDIR)/goto.$1.out
+	$(DIFF) $(WORKDIR)/goto.$1.out goto.ref
+
 # the rest are tests that fail currently for one reason or another
 $(WORKDIR)/fields.$1.$2.prg: fields.c | $(WORKDIR)
 	@echo "FIXME: " $$@ "currently will fail."

=== test/ref/Makefile ===
--- 
+++ 
@@ -60,16 +60,6 @@
 $(DIFF): ../bdiff.c | $(WORKDIR)
 	$(CC) $(CFLAGS) -o $@ $<
 
-# Some files have "K & R"-style syntax.  Therefore, some forward
-# function-declarations don't match the later function definitions.
-# Those programs fail when fastcall is used; but, the cdecl calling convention
-# tolerates those conflicts.  Therefore, make their functions default to cdecl.
-#
-$(WORKDIR)/init.%.prg   \
-$(WORKDIR)/switch.%.prg \
-$(WORKDIR)/yacc.%.prg   \
-$(WORKDIR)/yaccdbg.%.prg: CC65FLAGS += -Wc --all-cdecl
-
 # "yaccdbg.c" includes "yacc.c".
 # yaccdbg's built files must depend on both of them.
 #

=== test/val/Makefile ===
--- 
+++ 
@@ -44,16 +44,6 @@
 $(WORKDIR):
 	$(call MKDIR,$(WORKDIR))
 
-# Some files have "K & R"-style syntax.  Therefore, some forward
-# function-declarations don't match the later function definitions.
-# Those programs fail when fastcall is used; but, the cdecl calling convention
-# tolerates those conflicts.  Therefore, make their functions default to cdecl.
-#
-$(WORKDIR)/cq4.%.prg  \
-$(WORKDIR)/cq71.%.prg \
-$(WORKDIR)/cq81.%.prg \
-$(WORKDIR)/cq84.%.prg: CC65FLAGS += -Wc --all-cdecl
-
 define PRG_template
 
 $(WORKDIR)/%.$1.$2.prg: %.c | $(WORKDIR)

=== debian/changelog ===
cc65 (2.19-1) unstable; urgency=medium

  * New upstream release.
  * Update debhelper level to 12 .
  * Update Standards-Version to 4.5.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 26 Nov 2020 22:46:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper (>= 11), linuxdoc-tools
-Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 12), linuxdoc-tools
+Standards-Version: 4.5.1
 Homepage: https://cc65.github.io/cc65/
 
 Package: cc65

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,6 @@
 	dh_auto_install -- PREFIX=/usr
 
 %:
-	dh $@
+	dh $@ --no-parallel
 
 .PHONY: override_dh_auto_build override_dh_auto_install

=== debian/watch ===
version=4
opts=uversionmangle=s/^(\d)_?(\d)_?(\d)$/$1.$2.$3/;s/^(\d)_?(\d)$/$1.$2/ \
https://github.com/cc65/cc65/tags .*/V?(\d[\d\.]+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz|zip)
